***==========================================================================***
***                                                                          ***
***   SuperBASIC-Erweiterung um LOADF (Lade File), FONT (selektiere Font),   ***
***   ALLOC (Alloziere Speicherplatz im Common Heap), RELEASE (gebe          ***
***   Speicherplatz im Common Heap frei), CHAR_INC (selektiere horizontalen  ***
***   und vertikalen Zeichenabstand), FILE_LEN (Lnge eines Files),          ***
***   FREE_SPACE (Anzahl freier Blcke auf einem Speichermedium), SYS_VARS,  ***
***   CLEAR_MEM, MOVE_MEM, ODDP, CURSOR_ON und CURSOR_OFF.                   ***
***                                                                          ***
***                Copyright (c) 1986-1993 by Michael Humann                ***
***                                                                          ***
***==========================================================================***

            GET "flp1_standard"

bv.chbas    equ  $30                   Zeiger auf BASIC Kanaltabelle (Basis).
bv.chp      equ  $34                   Zeiger auf BASIC Kanaltabelle (Ende).
bv.rip      equ  $58                   Zeiger auf BASIC Stack (Top).
sd.xinc     equ  $26                   Cursor-Inkrement (Window Def. Block).
sd.cattr    equ  $42                   Character Attribut (Window Def. Block).
extd_width  equ  %00100000             Maske fr extended width Bit (SD.CATTR).
semaphor    equ  15                    Semaphor fr Buffer-Nutzung.
true_exp    equ  $801                  Wahrheitswert 'wahr' (Exponent)
true_mant   equ  $40000000             Wahrheitswert 'wahr' (Mantisse)

*==============================================================================*
*                                                                              *
*   Die folgende Initialisierungsroutine bindet die zustzlichen Prozeduren    *
*   und Funktionen in das SuperBASIC-System ein.                               *
*                                                                              *
*==============================================================================*

            lea proc_def,A1            Startadresse des Definitionsblocks.
            move.w bp.init,A2
            jmp (A2)

proc_def    dc.w 7                     Sieben Prozeduren:
            dc.w font-*                  Adresse
            dc.b 4,'FONT'                und Name der ersten ...
            dc.w release-*               ... zweiten ...
            dc.b 7,'RELEASE'
            dc.w char_inc-*              ... dritten ...
            dc.b 8,'CHAR_INC'
            dc.w cursor_on-*             ... vierten ...
            dc.b 9,'CURSOR_ON'
            dc.w cursor_off-*            ... fnften ...
            dc.b 10,'CURSOR_OFF'
            dc.w clear_mem-*             ... sechsten ...
            dc.b 9,'CLEAR_MEM'
            dc.w move_mem-*              ... und siebten Prozedur.
            dc.b 8,'MOVE_MEM'
            dc.w 0                     Ende der Prozedurdefinitionen.
            dc.w 6                     Sechs Funktionen:
            dc.w file_len-*              Adresse 
            dc.b 8,'FILE_LEN'            und Name der ersten ...
            dc.w loadf-*                 ... zweiten ...
            dc.b 5,'LOADF'
            dc.w alloc-*                 ... dritten ...
            dc.b 5,'ALLOC'
            dc.w free_space-*            ... vierten ...
            dc.b 10,'FREE_SPACE'
            dc.w sys_vars-*              ... fnften ...
            dc.b 8,'SYS_VARS'
            dc.w oddp-*                  ... und sechsten Funktion.
            dc.b 4,'ODDP'
            dc.w 0                     Ende der Funktionsdefinitionen.

buffer      dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

*==============================================================================*
*                                                                              *
*   SYS_VARS ist eine BASIC-Funktion, die die Startadresse der Systemvariablen *
*   zurckgibt.                                                                *
*                                                                              *
*   Syntax: SYS_VARS = <adresse>                                               *
*                                                                              *
*==============================================================================*

sys_vars    bsr.s expand_stack_for_fp_result
            qdos 1,mt.inf              Get system information ...
            move.l A0,D0               Startadresse in A0 ...
            bra return_lint            ... zurckgeben

expand_stack_for_fp_result
            moveq #6,D1
            vector bv.chrix,A2
            move.l bv.rip(A6),D7
            rts

*==============================================================================*
*                                                                              *
*   ODDP ist eine BASIC-Funktion, die berprft, ob eine ganze Zahl ungerade   *
*   ist. <integer> darf auch eine Floating-Point Zahl ohne Nachkommastellen    *
*   sein.                                                                      *
*                                                                              *
*   Syntax: ODDP (<integer>) = 0 | 1                                           *
*                                                                              *
*==============================================================================*

oddp        bsr.s expand_stack_for_fp_result
            vectorp ca.gtlin,A2,exit1  Hole 32-Bit Integer Argumente
            move.l 0(A6,A1.l),D0       Argument in D0
            subq.l #6,D7               Platz fr FP-Resultat auf dem Stack
            move.l D7,bv.rip(A6)       Stackpointer in BV.RIP speichern
            btst #0,D0                 Argument gerade oder ungerade?
            beq.s its_even
            move.w #true_exp,0(A6,D7.l) Resultat ist 1.0 (wahr)
            move.l #true_mant,2(A6,D7.l)
            bra.s return_truth
its_even    move.w #0,0(A6,D7.l)       Resultat ist 0.0 (falsch)
            move.l #0,2(A6,D7.l)
return_truth
            moveq #2,D4                Resultattyp ist FP.
            moveq #0,D0                Kein Fehler.
            rts

*==============================================================================*
*                                                                              *
*   FONT ist eine BASIC-Prozedur, die den Zeichensatz fr den angegebenen      *
*   oder den Defaultkanal (#1) selektiert. Statt der Adresse eines Fonts kann  *
*   auch 0 fr den Standardfont angegeben werden.                              *
*                                                                              *
*   Syntax: FONT [channel],first_font_address,second_font_address              *
*                                                                              *
*==============================================================================*
            SPC 1
font        bsr.s get_ch_id            Channel ID in A0
            vectorp ca.gtlin,A2,exit1  Long (32 Bit) Integers auf den Stack.
            arg_no_test 2,err_bp1      Zwei Integers? Sonst Parameterfehler.
            move.l 4(A6,A1.l),A2       Drittes Argument in A2.
            move.l 0(A6,A1.l),A1       Zweites Argument in A1.
            qdos_io sd.fount,-1        Selektiere den gewnschten Font.
exit1       rts
            SPC 2
*==============================================================================*
*                                                                              *
*   GET_CH_ID holt (sofern vorhanden) ein Argument vom Typ Kanalnummer         *
*   (Integer mit "#" Prfix) auf den Stack und bestimmt den zugehrigen        *
*   Channel_ID. In Abwesenheit einer Kanalnummer wird #1 angenommen.           *
*                                                                              *
*   Resultat: Channel ID in A0. Im Mierfolgsfall wird D0 der Fehlercode       *
*             zugewiesen und GET_CH_ID kehrt zum vorletzten Aufrufer zurck.   *
*                                                                              *
*   Vernderte Register: D6, A0, A2, A3 (zeigt auf nchstes Argument), D0      *
*                        (Fehlercode).                                         *
*                                                                              *
*==============================================================================*
            SPC 1
get_ch_id   moveq #1,D6                Initialisiere D6 mit Default (Kanal #1)
            cmpa.l A3,A5               Irgendwelche Argumente?
            beq.s find_id              Nein, bleibe beim Default.
            btst #7,1(A6,A3.l)         Hat das erste Argument einen "#" Prfix?
            beq.s find_id              Nein, bleibe beim Default.
            move.l A5,-(A7)            Manipulation der Zeiger auf die Argu-
            move.l A3,A5               mente, so da CA.GTINT nur das erste
            addq.l #8,A5               Argument auf den Stack holt.
            move.l A5,-(A7)
            vector ca.gtint,A2         Erstes Argument auf den Stack.
            move.l (A7)+,A3            Restaurieren von A3 und A5 (aber A3
            move.l (A7)+,A5            zeigt jetzt auf das zweite Argument!).
            bne.s bad_chan             berprfe Statusregister nach CA.GTINT.
            move.w 0(A6,A1.l),D6       Kanalnummer vom Stack nach D6.
find_id     mulu #40,D6                Index in die BASIC Kanaltabelle in D6
            add.l bv.chbas(A6),D6      Addiere Anfang der Kanaltabelle.
            cmp.l bv.chp(A6),D6        Sind wir innerhalb der Tabelle?
            bge.s err_no               Nein, "Not open" Fehler.
            move.l 0(A6,D6.L),D0       Channel ID nach D0 ...
            bmi.s err_no               ... falls negativ "not open".
            move.l D0,A0               Channel ID in A0.
exit2       rts
err_no      moveq #err.no,D0           Fehlerausgang: "Channel not open".
            bra.s bad_chan1
bad_chan    moveq #err.bp,D0           Fehlerausgang: "Bad parameter".
bad_chan1   addq.l #4,A7               Pop die Rcksprungadresse.
            rts
            SPC 2
*==============================================================================*
*                                                                              *
*   CHAR_INC ist eine BASIC-Prozedur, die es ermglicht, den horizontalen und  *
*   vertikalen Zeichenabstand zu bestimmen.                                    *
*                                                                              *
*   Syntax: CHAR_INC [channel],x_inc,y_inc                                     *
*                                                                              *
*==============================================================================*
            SPC 1
char_inc    bsr.s get_ch_id            Channel ID in A0.
            vectorp ca.gtint,A2,exit2  Integers auf den Stack.
            subq.w #2,D3               Zwei Integers?
err_bp1     bne err_bp                 Nein, Parameterfehler.
            move.l 0(A6,A1.l),D2       Zweites & drittes Argument in D2.
            lea set_char_inc,A2        Startadresse.
            qdos_io sd.extop,-1        Aufruf als EXTended OPeration.
            move.w D2,D4               
            andi.l #255,D4             Y_INC (neu) in D4.
            lea buffer,A1              Adresse des enquiry block in A1 ...
            move.l A1,A4               ... und A4
            bsr.s wait                 Ist er frei?
            qdosp 3,sd.pxenq,exit2     Cursorposition abfragen.
            move.w 4(A4),D1            X_POS in D1.
            move.w 6(A4),D2            Y_POS in D2.
            add.w D2,D4                Y_POS + Y_INC (neu) in D4.
            move.w 2(A4),D0            Untere Kante des Cursor-Rechtecks ...
            clr.b semaphor(A4)
            sub.w D0,D4                ... innerhalb des Fensters?
            ble.s exit_ok              OK.
            sub.w D4,D2                Sonst Y_POS um Differenz hher.
            qdos 3,sd.pixp             Setze neue Cursorposition.
            neg.w D4                   Scrolling-Distanz negativ (nach oben).
            move.w D4,D1
            qdos 3,sd.scrol            Scrollen nach oben um D1 Pixel.
exit_ok     moveq #0,D0                Kein Fehler ...
            rts                        ... und zurck.

wait        tas semaphor(A1)
            bne.s wait
            rts
            SPC 2
*==============================================================================*
*                                                                              *
*   SET_CHAR_INC ist ein Unterprogramm, das - indirekt ber SD.EXTOP aufge-    *
*   rufen - fr das Fenster, auf dessen definition block A1 zeigt, den hori-   *
*   zontalen und vertikalen Zeichenabstand (in der hher- bzw. niederwertigen  *
*   Hlfte von D2) setzt.                                                      *
*                                                                              *
*==============================================================================*
            SPC 1
set_char_inc
            move.l D2,sd.xinc(A0)      Setze Zeichenabstand ...
            ori.b #extd_width,sd.cattr(A0)  ... setze extended width Bit ...
            bra.s exit_ok              ... und zurck.
            SPC 2
*==============================================================================*
*                                                                              *
*   RELEASE ist eine BASIC-Prozedur, die einen mit ALLOC allozierten Block     *
*   wieder freigibt.                                                           *
*                                                                              *
*   Syntax: RELEASE address_of_block                                           *
*                                                                              *
*==============================================================================*
            SPC 1
release
            vectorp ca.gtlin,A2,exit3  Hole ein Argument auf den Stack.
            arg_no_test 1,err_bp       Wirklich blo eins? Sonst Parameterfehler.
            move.l 0(A6,A1.l),A0       Argument in A0 (Adresse eines Blocks).
            qdos 1,mt.rechp            Block im Common Heap freigeben ...
exit3       rts                        ... und zurck ins BASIC.
            SPC 2
*==============================================================================*
*                                                                              *
*   FILE_LEN ist eine BASIC-Funktion, die zu einem File (oder Directory)       *
*   dessen Lnge in Bytes zurckgibt. Da FILE_LEN fr den Fall, da das ange-  *
*   gebene File nicht existiert, das Resultat 0 liefert, kann FILE_LEN auch    *
*   benutzt werden, um vor einem OPEN zu testen, ob das gewnschte File auch   *
*   existiert.                                                                 *
*                                                                              *
*   Syntax: FILE_LEN (string)                                                  *
*                                                                              *
*   Resultat: Wenn das File existiert: die Lnge des Files in Bytes; sonst 0.  *
*                                                                              *
*==============================================================================*
            SPC 1
file_len    move.l bv.rip(A6),D7       Top-of-stack in D7
            bsr.s get_string           Zeiger auf Filename in A0.
            bsr.s read_head            ffne das File und lies den Header.
            beq.s do_close             War READ_HEAD erfolgreich?
            moveq #0,D0                Nein, Resultat = 0.
            bra.s skip_close           Nicht schlieen wg. Fehlschlag von OPEN.
do_close
            qdos 2,io.close            Schlieen des Files.
            move.l (A2),D0             Lnge in D0 (A2 zeigt auf Header).
            addi.l #64,D0              Addiere 64 Byte fr den Header.
skip_close  clr.b semaphor(A2)
            bra return_lint            Rckkehr mit Resultat D0.
            SPC 2
err_bp      moveq #err.bp,D0           Fehlerausgang: "Bad parameter".
exit_tst    tst.l D0                   Setze Statusregister.
            rts
            SPC 2
*==============================================================================*
*                                                                              *
*   READ_HEAD ffnet die Datei, auf deren Namen A0 zeigt und liest den Header  *
*   (d.h. die ersten 14 Bytes) in den Buffer BUFFER ein. Das erste 32 Bit      *
*   Wort darin enthlt die Lnge des Files. Das File bleibt beim Verlassen     *
*   von READ_HEAD nur dann geffnet, wenn sowohl IO.OPEN als auch FS.HEADR     *
*   erfolgreich waren.                                                         *
*                                                                              *
*   Resultat: Zeiger auf File Header in A2, Channel_ID in A0.                  *
*                                                                              *
*   Vernderte Register: D1 (Job ID), D2, D3, A0, A2, D0 (Fehlercode).         *
*                                                                              *
*   Statusregister: durch TST von D0 (Fehlercode) gesetzt.                     *
*                                                                              *
*==============================================================================*
            SPC 1
read_head   moveq #0,D3                Exklusives, existierendes File.
            suba.l A2,A2               A2 lschen.
            movea.w 0(A6,A0.L),A2      Lnge des Filenamens in A2.
            adda.l A0,A2               
            cmpi.b #'_',1(A6,A2.L)     Filename endet auf "_"?
            bne.s no_dir               Nein, keine Directory.
            moveq #4,D3                Das File ist eine Directory.
no_dir
            for_this_job
            trap #4                    A0 ist relativ zu A6
            qdosp 2,io.open,exit_tst   File geffnet, Channel_ID in A0
            moveq #14,D2               Lnge des Buffers.
            lea buffer,A1              Adresse des Buffers in A1 ...
            move.l A1,A2               ... und in A2.
            bsr wait                   Ist der Buffer frei?
            qdos_io fs.headr,-1        Lies die ersten 14 Bytes des Headers.
            if_no_error exit_tst       Erfolgreich?
            move.l D0,-(A7)            Fehlercode auf Stack.
            qdos 2,io.close            File schlieen.
            move.l (A7)+,D0            Fehlercode restaurieren.
            clr.b semaphor(A2)
            bra.s exit_tst             Und zurck.
            SPC 2
*==============================================================================*
*                                                                              *
*   GET_STRING holt ein Argument vom Typ String auf den Stack und prft, ob    *
*   es das einzige war.                                                        *
*                                                                              *
*   Resultat: Zeiger auf erstes Argument in A0. Wenn ein Fehler auftrat,       *
*             kehrt GET_STRING zum vorletzten Aufrufer zurck.                 *
*                                                                              *
*   Vernderte Register: A0, A2, D3, D0 (Fehlercode).                          *
*                                                                              *
*==============================================================================*
            SPC 1
get_string
            vectorp ca.gtstr,A2,bad_string   Hole einen String auf den Stack.
            arg_no_test 1,bad_string   Nur ein String? Sonst Parameterfehler.
            movea.l A1,A0              Zeiger auf Stacktop in A0 (relativ zu A6)
            rts
bad_string  addq.l #4,A7               Pop die Rcksprungadresse.
            bra.s err_bp
            SPC 2
*==============================================================================*
*                                                                              *
*   LOADF ist eine BASIC-Funktion, die ein File in einen im Common Heap        *
*   allozierten Speicherblock einliest.                                        *
*                                                                              *
*   Syntax: LOADF (string)                                                     *
*                                                                              *
*   Resultat: Startadresse des Blocks im Common Heap.                          *
*                                                                              *
*==============================================================================*
            SPC 1
loadf       move.l bv.rip(A6),D7       Top-of-stack in D7
            bsr.s get_string           Zeiger auf Filename in A0
            bsr.s read_head            ffne das File und lies den Header.
            bne.s exit                 Fehler bei READ_HEAD, gib's auf.
            move.l (A2),D1             Lnge des File in D1.
            clr.b semaphor(A2)         Semaphor zurcksetzen.
            movem.l D1/A0,-(A7)        Rette D1 und A0 (Channel_ID).
            moveq #0,D2                Fr diesen Job (BASIC).
            qdos 1,mt.alchp            Alloziere Speicherplatz im Common Heap.
            move.l A0,A2               Adresse des allozierten Blocks in A2.
            movem.l (A7)+,D2/A0        A0 restaurieren, Lnge in D2.
            if_error close_file        Allokation erfolgreich?
            move.l A2,A1               Startadresse in A1 und A2.
            qdos_io fs.load,-1         Laden des Files.
close_file  move.l D0,-(A7)            Rette Fehlercode auf den Stack.
            qdos 2,io.close            Schlieen des Files.
            move.l (A7)+,D0            Fehlercode restaurieren.
            if_error exit              Waren wir erfolgreich?
            move.l A2,D0               Startadresse in D0.
            SPC 2
*==============================================================================*
*                                                                              *
*   RETURN_LINT hinterlt einen in das Floating Point Format konvertierten    *
*   positiven 32 Bit Integer in D0 auf dem Stack und kehrt mit RTS zum auf-    *
*   rufenden Programm zurck.                                                  *
*                                                                              *
*==============================================================================*
            SPC 1
return_lint subq.l #6,D7               Platz fr FP-Resultat auf dem Stack.
            move.l D7,bv.rip(A6)       Stackpointer in BV.RIP speichern.
            moveq #0,D1                Exponent = 0
            move.l D0,D2               Kopie des Resultats nach D2.
            beq.s push_stack           Wenn Resultat = 0 bleibt auch Exponent 0.
            move.w #$81F,D1            Nein, wir mssen normalisieren.
norm_loop   asl.l #1,D0                Mantisse = Mantisse * 2.
            bvs.s push_stack           berlauf? Dann sind wir fertig.
            subq.l #1,D1               Exponent = Exponent - 1.
            move.l D0,D2               Alter Wert nach D2 ...
            bra.s norm_loop            ... und nochmal.

push_stack  move.w D1,0(A6,D7.l)       Exponent auf den Stack.
            move.l D2,2(A6,D7.l)       Mantisse auf den Stack.
            moveq #2,D4                Resultattyp ist Real.
exit_ok1    moveq #0,D0                Kein Fehler.
exit        rts
            SPC 2
*==============================================================================*
*                                                                              *
*   ALLOC ist eine BASIC-Funktion, die einen Block im Common Heap alloziert    *
*   und dessen Startadresse zurckgibt. Wenn die Allokation fehlschlug ("Out   *
*   of memory" Fehler) ist das Resultat 0.                                     *
*                                                                              *
*   Syntax: ALLOC (number_of_bytes_required)                                   *
*                                                                              *
*   Resultat: Falls erfolgreich: Adresse des allozierten Blocks; sonst 0.      *
*                                                                              *
*==============================================================================*
            SPC 1
alloc       move.l bv.rip(A6),D7       Zeiger auf BASIC-Stack in D7.
            vectorp ca.gtlin,A2,exit   Hole ein Argument auf den Stack.
            subq.w #1,D3               Wirklich nur eins?
            bne err_bp                 Nein, Parameterfehler.
            move.l 0(A6,A1.l),D1       Argument in D1.
            moveq #-1,D2               Fr diesen Job.
            qdos 1,mt.alchp            Alloziere Speicherplatz im Common Heap.
            if_no_error alloc_exit     Allokation erfolgreich?
            suba.l A0,A0               Nein, nichts alloziert: Resultat = 0.
alloc_exit  move.l A0,D0               Resultat in D0.
            bra.s return_lint          Zurck mit Resultat auf dem Stack.
            SPC 2
*==============================================================================*
*                                                                              *
*   FREE_SPACE ist eine BASIC-Funktion, die den freien Speicherplatz auf       *
*   einem Speichermedium (in Blcken a 512 KB) zurckgibt. Wenn es fr das     *
*   angegebene Device kein Medium gibt (d.h. keine Cartridge bzw. Floppy im    *
*   Laufwerk ist) gibt FREE_SPACE als Resultat 0 zurck.                       *
*                                                                              *
*   Syntax: FREE_SPACE (device)                                                *
*                                                                              *
*   Resultat: Die Anzahl freier Blcke.                                        *
*                                                                              *
*==============================================================================*
            SPC 1
free_space  move.l bv.rip(A6),D7       Top-of-stack in D7
            bsr get_string             Zeiger auf Filename in A0.
            trap #4                    Weil A0 relativ  zu A6 ist.
            moveq #0,D2                Resultat per Default = 0.
            moveq #4,D3                Information fr IO.OPEN: ffne Directory.
            for_this_job
            qdosp 2,io.open,exit_fsp   Directory geffnet, Channel_ID in A0.
            lea buffer,A1              Adresse des Buffers in A1 ...
            move.l A1,A4               ... und A4.
            bsr wait                   Ist der Buffer frei?
            qdos_io fs.mdinf,-1        Hole Informationen ber das Medium.
            if_error close_dir         Mierfolg? Dann bleibt D2 = 0.
            swap D1                    Anzahl freier Blcke vom MSW ins LSW.
            move.w D1,D2               Anzahl freier Blcke in D2.
close_dir   clr.b semaphor(A4)         Setze Semaphor zurck.
            qdos 2,io.close            Schlieen des Files.
exit_fsp    subq.l #2,D7               Mach Platz fr zwei Bytes auf dem Stack.
            move.l D7,bv.rip(A6)       bertragen nach BV.RIP.
            moveq #3,D4                Typ des Resultats ist Integer.
            move.w D2,0(A6,D7.l)       Resultat auf den BASIC-Stack ...
            bra.s exit_ok1             ... und zurck.

*==============================================================================*
*                                                                              *
*   CURSOR_ON ist eine BASIC-Prozedur, die den Cursor fr den angegebenen      *
*   Kanal (oder, per Default, #1) einschaltet.                                 *
*                                                                              *
*   Syntax: CURSOR_ON [channel]                                                *
*                                                                              *
*==============================================================================*

cursor_on   bsr get_ch_id              Hole "channel" Argument (per Default #1).
            qdos_io sd.cure,-1         Enable Cursor.
            rts                        Zurck (ob mit oder ohne Fehler).

*==============================================================================*
*                                                                              *
*   CURSOR_OFF ist eine BASIC-Prozedur, die den (mit CURSOR_ON)                *
*   eingeschalteten Cursor wieder ausschaltet.                                 *
*                                                                              *
*   Syntax: CURSOR_OFF [channel]                                               *
*                                                                              *
*==============================================================================*

cursor_off  bsr get_ch_id              Hole "channel" Argument (per Default #1).
            qdos_io sd.curs,-1         Suppress Cursor.
            rts                        Zurck (ob mit oder ohne Fehler).

*==============================================================================*
*                                                                              *
*   CLEAR_MEM ist eine BASIC-Prozedur, die einen Speicherblock lscht.         *
*                                                                              *
*   Syntax: CLEAR_MEM <adresse>,<anzahl-bytes>                                 *
*                                                                              *
*==============================================================================*

clear_mem   
            vectorp ca.gtlin,A2,exit_mem
            arg_no_test 2,err_bp_mem
            move.l 0(A6,A1.l),D0      Adresse in D0 ...
            movea.l D0,A0             ... und A0
            move.l 4(A6,A1.l),D1      Lnge des Blocks in D1
            blt.s err_bp_mem
            btst #0,D0
            beq.s even_adr
            clr.b (A0)+               Byte an ungerader Adresse lschen
            subq.l #1,D1
even_adr    move.l D1,D2              Lnge in D1 und D2
            asr.l #2,D1               Lnge DIV 4 in D1
            andi.l #3,D2              Lnge MOD 4 in D2
            bra.s clear_loop_entry
clear_loop  clr.l (A0)+               Jeweils 4 Byte lschen
clear_loop_entry
            dbra D1,clear_loop
            bra.s clear_rest_loop_entry
clear_rest_loop
            clr.b (A0)+               Restliche 0 bis 3 Bytes lschen
clear_rest_loop_entry
            dbra D2,clear_rest_loop
            moveq #0,D0               Ohne Fehler ...
exit_mem    rts                       ... zurck

err_bp_mem  moveq #err.bp,D0          Parameterfehler
            rts

*==============================================================================*
*                                                                              *
*   MOVE_MEM ist eine BASIC-Prozedur, die einen Speicherblock an eine andere   *
*   andere Adresse verschiebt. Die <ziel-adresse> kann auch innerhalb des      *
*   zu verschiebenden Speicherblocks liegen.                                   *
*                                                                              *
*   Syntax: MOVE_MEM <quell-adresse>,<anzahl-bytes> TO <ziel-adresse>          *
*                                                                              *
*==============================================================================*

move_mem   
            vectorp ca.gtlin,A2,exit_mem
            arg_no_test 3,err_bp_mem
            move.l 0(A6,A1.l),D0      Zieladresse in D0 ...
            movea.l D0,A0             ... und A0
            move.l 4(A6,A1.l),D1      Lnge des Blocks in D1
            blt.s err_bp_mem
            movea.l 8(A6,A1.l),A1     Zieladresse in A1 ...
            cmpa.l A0,A1
            bhi.s move_bottom_up      Von unten nach oben kopieren
            bra.s move_loop1_entry    Von oben nach unten kopieren
move_loop1  move.b (A0)+,(A1)+
move_loop1_entry
            dbra D1,move_loop1
            moveq #0,D0
            rts
move_bottom_up
            adda.l D1,A0
            adda.l D1,A1
            bra.s move_loop2_entry
move_loop2  move.b -(A0),-(A1)
move_loop2_entry
            dbra D1,move_loop2
            moveq #0,D0
            rts

*==============================================================================*
            END
